c     main program   with comment by izumi 1998-03-30
c----------------------------------------------------------------------
c  ielm  : max. number of an element 
c  inode : max. number of a node
c  ird   : max. number of integration point in one element
c  igk   : max. size of stiffness matrix  inode*idim
c  ibn   : max. size of half band width
c  ibound: max. number of constrain (force and displacement)
c  ina   : max. number of integration point  ielm*ird
c  inmte : max. number of a node in a element --> 8
c  inmnm : max. size of element stiffness matrix  inmte*idim
c  imnum : max. number of the kind of material 
c  idm   : dimension
c  icom  : number of stress component (2-dim->4 ,3dim->6)
c----------------------------------------------------------------------
      include 'para.inc'
      include 'const.inc'
c----------------------------------------------------------------------
c  dndx1(i): dni/dxi, dndeta(i) : dni/deta
c  x(i) : x-coordinate of node i ,y(i) : y-coordinate 
c----------------------------------------------------------------------
      dimension dndxi(inmte),dndeta(inmte),x(inode),y(inode),
c----------------------------------------------------------------------
c  b(i,j) : elemental stiffness matrix
c  axi(i) : x-coordinate of i-th integration point ( -1 < axi  < 1 )
c  aeta(i): y-coordinate of i-th integration point ( -1 < aeta < 1 )
c  h(i)   : weight parameter of i-th integration point
c  d(i,j) : elastic matrix (1-x,2-y,3-z,4-xy)
c----------------------------------------------------------------------
     +     b(icom,inmnm),axi(ird),aeta(ird),h(ird),d(icom,icom),
c----------------------------------------------------------------------
c  c(i,j)  : bt(inmnm,4)*d(4,4)*b(4,inmnm) bt*d*b
c  ek(i,j) : element stiffness matrix 
c  nn(i,j) : node number of i-th local node of element j 
c----------------------------------------------------------------------
     +     c(inmnm,inmnm),ek(inmnm,inmnm),nn(inmte,ielm),
c----------------------------------------------------------------------
c  gk(i,j) : global stiffness matrix  i: matrix size  j:half band width
c  f(i)    : force vector of node i
c  ifor(i) : freedom number of i-th initial load point
c  fb(i)   : load value of i-th initial load point
c----------------------------------------------------------------------
     +     gk(igk,ibn),f(igk),ifor(ibound),fb(ibound),
c----------------------------------------------------------------------
c  idis(i) : freedom number of i-th initial disp. point
c  ub(i)   : disp. value of i-th initial disp. point
c  u(i)    : displacement value of i-th freedom
c  ep(i,j,k) : i-th component strain at j-th element
c                k-th local integration point
c  bm(i)   : for strain (b matrix for i-th integration point)
c  sg(i,j,k) : i-th component stress at j-th element
c                k-th local integration point
c  bt(i)   : transposed b(4,inmnm) matrix 
c  btd(i)  : bt(inmnm,4)*d(4,4)
c----------------------------------------------------------------------
c     +     idis(ibound),ub(ibound),u(igk),ep(icom,ina),
     +     idis(ibound),ub(ibound),u(igk),ep(icom,ielm,ird),
     +     bm(ina,icom,inmnm),sg(icom,ielm,ird),bt(inmnm,icom),
     +     btd(inmnm,icom),
c----------------------------------------------------------------------
ccc  yo(i)   : young modulus of i-th material 
ccc  po(i)   : poisson ratio of i-th material 
c  econ(i,j) : i-th elastic constants of j-th material
c  iecon(i)  : elastic character of i-th material
c  nom(i)  : material number of i-th element
c  nmte(i) : number of a node in i-th element
c  ngng(i) : number of integration point in i-th element
c  neus(i) : i : program node number , neus(i) : user element number 
c  nnus(i) : i : program node number , nnus(i) : user node number 
c----------------------------------------------------------------------
c     +     yo(imnum),po(imnum),nom(ielm),nmte(ielm),ngng(ielm)
     +  econ(9,imnum),iecon(imnum),nom(ielm),nmte(ielm),ngng(ielm),
     +  neus(ielm),nnus(inode)
c----------------------------------------------------------------------
c  n    : shape function ni
c  jinv : inverse of jacobian matrix
c  jm   : jacobian matrix
c----------------------------------------------------------------------
      double precision n(inmte),jinv(idim,idim),jm(idim,idim)
c      
      open(77,file='datacheck.dat')
      open(2,file='result.dat')
c--------------------------------------------------------------
c for subroutie data
c  ngauss : order of gauss integration
c  npara  : analysis condition (0:plain stress,1:plain strain)
c  t      : thickness
c  ntn    : total number of nodes
c  nte    : total number of elements
c  ntf    : total number of freedoms
c  ie     : element number(variables)
c  ntfor  : total number of freedoms with initial load
c  ntdis  : total number of freedoms with initial displacement
c  nna    : the total number of integration points
c  mnum   : number of the kind of material
c--------------------------------------------------------------
c      call data(a,nmte,ngauss,npara,econ,t,ntn,nte,ntf,
c     +     nn,x,y,ie,ntfor,ifor,fb,ntdis,idis,ub,ngng,nna,
c     +     nom,mnum,iecon)
      call data(a,nmte,econ,t,
     +     nn,x,y,ifor,fb,idis,ub,ngng,nom,iecon,neus,nnus)
c--- band width
c--------------------------------------------------------------
c  nb     : half band width
c--------------------------------------------------------------
      call band(nn,nmte)
c
      call check
c
c      call gauss(axi,aeta,h,nmte,ngauss)
      call clear(ek,gk,f)
      na=0
ccc for all element
      do 150 ie=1,nte
c--- gauss integration point
         call gauss(axi,aeta,h,nmte)
c--- elastic matrix 
         call dmat(econ,d,nom,iecon) 
ccc for all integration point
         do 100 kg=1,ngng(ie)
            xi=axi(kg)
            eta=aeta(kg)
            hnum=h(kg)
c--------------------------------------------------------------
c  na     : through number of integration point
c--------------------------------------------------------------
            na=na+1
c--------------------------------------------------------------
c  rx     : real space x-coordinate of integration pointc 
c              for axial symmetry element
c--------------------------------------------------------------
c--- apply to interpolation functions (n, dn/dxi, dn/deta)
            call int(xi,eta,n,dndxi,dndeta,nmte,rx,x,nn)
c--- jacobian matrix and its inverse matrix
c--------------------------------------------------------------
c  detj   : det[j]
c--------------------------------------------------------------
            call jmat(x,y,dndxi,dndeta,jm,jinv,detj,nn,nmte)
c b matrix
            call bmat(jinv,b,n,dndxi,dndeta,nmte,rx)
c b matrix for each integration point (na)
            call bmmat(b,na,bm,nmte)
c btdb matrix
            call bdbmat(b,c,d,nmte,bt,btd)
c element stiffness matrix 
            call gauss2(c,ek,hnum,n,x,detj,nmte,nn)
 100     continue
c
         call gauss3(nmte,ek,t)
c element stiffness --> global stiffness
         call merge(ek,nn,gk,nmte)
c clear element stiffness matrix 
         call clear2(ek,nmte)
 150  continue
c boundary condition
      call bound(ifor,fb,f,idis,ub,gk)
c gauss-erase-method
      call solve(gk,f,u)
c strain b*a
      call strain(nn,u,ep,bm,nmte,ngng)
c stress d*strain
      call stress(d,ep,sg,ngng)
c output
      call output(u,ep,sg,ngng,neus,nnus)
c output(averange at node)
      call output_av(u,ep,sg,ngng,nmte,neus,nnus,nn)
c
      close(2)
c
      stop
      end
